//----------Q.c lib3D_MEC expoted-----------

//For increased velocity use GSL HAVE_INLINE and GSL_RANGE_CHECK_OFF preprocesor directive to compile:

// gcc -DHAVE_INLINE = 1 -DGSL_RANGE_CHECK_OFF = 1 ... ---

#include <stdio.h>
#include <gsl/gsl_vector.h>
#include "var_def.h"
#include "gen_coord_vect_def.h"
#include "gen_vel_vect_def.h"
#include "gen_accel_vect_def.h"
#include "unknowns_vect_def.h"
#include <math.h>
#define theta1 gsl_vector_get ( q , 0 )
#define theta2 gsl_vector_get ( q , 1 )
#define dtheta1 gsl_vector_get ( dq , 0 )
#define dtheta2 gsl_vector_get ( dq , 1 )
#define ddtheta1 gsl_vector_get ( ddq , 0 )
#define ddtheta2 gsl_vector_get ( ddq , 1 )
#define Fgp12 gsl_vector_get ( unknowns , 0 )
#define Fgp13 gsl_vector_get ( unknowns , 1 )
#define Fp1p22 gsl_vector_get ( unknowns , 2 )
#define Fp1p23 gsl_vector_get ( unknowns , 3 )
extern double atom0;
extern double atom1;
extern double atom2;
extern double atom3;
extern double atom4;
extern double atom5;
extern double atom7;
extern double atom8;
extern double atom9;
extern double atom10;
extern double atom11;
extern double atom12;
extern double atom13;
extern double atom14;
extern double atom15;
extern double atom16;
extern double atom17;
extern double atom18;
extern double atom19;
extern double atom20;
extern double atom21;
extern double atom22;
extern double atom23;
extern double atom24;
extern double atom25;
extern double atom26;
extern double atom27;
extern double atom28;
extern double atom29;
extern double atom30;
extern double atom31;
extern double atom33;
extern double atom36;
extern double atom37;
extern double atom38;
extern double atom39;
extern double atom40;
extern double atom41;
extern double atom43;
extern double atom44;
extern double atom45;
extern double atom46;
extern double atom47;
extern double atom48;
extern double atom49;
extern double atom50;
extern double atom51;
extern double atom52;
extern double atom53;
extern double atom54;
extern double atom55;
extern double atom56;
extern double atom57;
extern double atom58;
extern double atom59;
extern double atom60;
extern double atom61;
extern double atom62;
extern double atom63;
extern double atom64;
extern double atom65;
extern double atom66;
extern double atom67;
extern double atom68;
extern double atom69;
extern double atom70;
extern double atom71;
extern double atom72;
extern double atom73;
extern double atom74;
extern double atom76;
extern double atom81;
extern double atom83;
extern double atom84;
extern double atom87;
extern double atom88;
extern double atom89;
extern double atom93;
extern double atom75;
extern double atom77;
extern double atom78;
extern double atom79;
extern double atom80;
extern double atom82;
extern double atom85;
extern double atom86;
extern double atom90;
extern double atom91;
extern double atom92;
extern double atom94;
gsl_vector * Phi = NULL;
gsl_vector * Q ()
{
size_t n_comp = 2;
if ( Phi == NULL )
 {
    Phi = gsl_vector_alloc ( n_comp );
/*constant*/ atom0 = -mpendulum1*g;
/*constant*/ atom1 = -g*mpendulum2;
 }
 atom2 = -(1.0/2.0)*dtheta1*l1;
 atom3 = -(1.0/2.0)*l1*ddtheta1;
 atom4 = dtheta1*atom2;
 atom5 = cos(theta2);
 atom7 = sin(theta2);
 atom8 = -(1.0/2.0)*l2*atom7;
 atom9 = (1.0/2.0)*l2*atom5;
 atom10 = atom9+l1;
 atom11 = -dtheta2*atom9;
 atom12 = dtheta2*atom8;
 atom13 = -dtheta1*atom10;
 atom14 = dtheta1*atom8;
 atom15 = atom11+atom13;
 atom16 = atom12+atom14;
 atom17 = -atom10*ddtheta1;
 atom18 = -atom9*ddtheta2;
 atom19 = -dtheta2*atom16;
 atom20 = atom18+atom19;
 atom21 = atom17+atom20;
 atom22 = atom8*ddtheta1;
 atom23 = atom8*ddtheta2;
 atom24 = atom11-atom9*dtheta1;
 atom25 = dtheta2*atom24;
 atom26 = atom23+atom25;
 atom27 = atom22+atom26;
 atom28 = -dtheta1*atom16;
 atom29 = atom15*dtheta1;
 atom30 = atom28+atom21;
 atom31 = atom27+atom29;
 atom33 = I1*ddtheta1;
 atom36 = I2*ddtheta1;
 atom37 = I2*ddtheta2;
 atom38 = atom37+atom36;
 atom39 = -mpendulum2*atom30;
 atom40 = -atom31*mpendulum2;
 atom41 = cos(theta1);
 atom43 = sin(theta1);
 atom44 = atom39*atom41;
 atom45 = -atom43*atom40;
 atom46 = atom44+atom45;
 atom47 = atom43*atom39;
 atom48 = atom40*atom41;
 atom49 = atom47+atom48;
 atom50 = atom49+atom1;
 atom51 = -atom10*atom41;
 atom52 = -atom43*atom8;
 atom53 = atom52+atom51;
 atom54 = -atom43*atom10;
 atom55 = atom8*atom41;
 atom56 = atom55+atom54;
 atom57 = atom46*atom53;
 atom58 = atom50*atom56;
 atom59 = atom57+atom58;
 atom60 = -mpendulum1*atom3;
 atom61 = -mpendulum1*atom4;
 atom62 = atom60*atom41;
 atom63 = -atom43*atom61;
 atom64 = atom62+atom63;
 atom65 = atom43*atom60;
 atom66 = atom61*atom41;
 atom67 = atom65+atom66;
 atom68 = atom67+atom0;
 atom69 = -(1.0/2.0)*l1*atom41;
 atom70 = -(1.0/2.0)*atom43*l1;
 atom71 = atom64*atom69;
 atom72 = atom68*atom70;
 atom73 = atom71+atom72;
 atom74 = -atom9*atom41;
 atom76 = -atom43*atom9;
 atom81 = atom73+atom59-atom38-atom33;
 atom83 = -(atom43*atom43)*mpendulum1*(l1*l1)/4.0-I1+(-atom52*mpendulum2-atom51*mpendulum2)*atom53-mpendulum1*(l1*l1)*(atom41*atom41)/4.0-I2+(-atom54*mpendulum2-atom55*mpendulum2)*atom56;
 atom84 = (-atom52*mpendulum2-atom74*mpendulum2)*atom53+(-atom55*mpendulum2-atom76*mpendulum2)*atom56-I2;
 atom87 = atom83*ddtheta1;
 atom88 = atom84*ddtheta2;
 atom89 = atom88+atom87;
 atom93 = -atom89+atom81;
 atom75 = atom52+atom74;
 atom77 = atom76+atom55;
 atom78 = atom75*atom46;
 atom79 = atom50*atom77;
 atom80 = atom79+atom78;
 atom82 = atom80-atom38;
 atom85 = atom75*(-atom52*mpendulum2-atom51*mpendulum2)-I2+atom77*(-atom54*mpendulum2-atom55*mpendulum2);
 atom86 = (-atom52*mpendulum2-atom74*mpendulum2)*atom75-I2+atom77*(-atom55*mpendulum2-atom76*mpendulum2);
 atom90 = atom85*ddtheta1;
 atom91 = atom86*ddtheta2;
 atom92 = atom91+atom90;
 atom94 = -atom92+atom82;
gsl_vector_set ( Phi , 0 , -atom93 );
gsl_vector_set ( Phi , 1 , -atom94 );
return Phi;
}
